using System;
using System.Threading;

namespace accel_compass
{
	/// <summary>
	/// Summary description for BumpDetectBehavior.
	/// </summary>
	public class BumpDetectBehavior
	{
		private bool runFlag = false;
		private bool terminateFlag = false;
		private ThreadStart threadStart = null;
		private Thread thread = null;

		private Robot _robot = null;

		public BumpDetectBehavior(Robot r)
		{
			_robot = r;
			threadStart = new ThreadStart(threadFunc);
			thread = new Thread(threadStart);
			thread.Start();
		}

		public void start()
		{
			runFlag = true;
		}

		public void stop()
		{
			runFlag = false;
		}

		public void terminate()
		{
			this.stop();
			terminateFlag = true;
		}

		private void threadFunc()
		{
			while(!terminateFlag)
			{
				while(runFlag)
				{
					double a1 = _robot.getAccel1ActualValue();
					double a2 = _robot.getAccel2ActualValue();

					double thresh = 2.5;

					if( (Math.Abs(a1)>thresh) || (Math.Abs(a2)>thresh))
					{
						_robot.notifyBump();
					}

					Thread.Sleep(10);
				}

				Thread.Sleep(100);
			}

			
		}


	}
}
