using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using NationalInstruments.DAQmx;

namespace accel_compass
{
	/// <summary>
	/// Summary description for MainForm.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label labelMotorLeft;
		private System.Windows.Forms.Label labelMotorRight;
		private System.Windows.Forms.TrackBar trackBarMotorLeft;
		private System.Windows.Forms.TrackBar trackBarMotorRight;
		private Robot robot;
		private System.Windows.Forms.Button buttonCalibrateAccel;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label accelDev1Label;
		private System.Windows.Forms.Label accelDev2Label;
		private System.Windows.Forms.Button ResetOdometry;
		private System.Windows.Forms.Button StartOdometry;
		private System.Windows.Forms.Button StopOdometry;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.Label odometryXLabel;
		private System.Windows.Forms.Label odometryYLabel;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.Label accel1Label;
		private System.Windows.Forms.Label accel2Label;
		private System.Windows.Forms.Label label11;
		private System.Windows.Forms.Label label12;
		private System.Windows.Forms.Label vxLabel;
		private System.Windows.Forms.Label vyLabel;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label headingLabel;
		private System.Windows.Forms.Button StartCompassButton;
		private System.Windows.Forms.Button StopCompassButton;
		private System.Windows.Forms.Timer timerAccelerometer;
		private System.Windows.Forms.Timer timerCompass;
		private System.Windows.Forms.GroupBox groupBox4;
		private System.Windows.Forms.Button StopDigitalCompassButton;
		private System.Windows.Forms.Button StartDigitalCompassButton;
		private System.Windows.Forms.Label digitalHeadingLabel;
		private System.Windows.Forms.Label label13;
		private System.Windows.Forms.Timer timerDigitalCompass;
		private System.Windows.Forms.Timer timerGuiUpdate;
		private System.Windows.Forms.GroupBox groupBox5;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label14;
		private System.Windows.Forms.Button StartHeadingFollowButton;
		private System.Windows.Forms.Button StopHeadingFollowButton;
		private System.Windows.Forms.NumericUpDown desiredHeadingUpDown;
		private System.Windows.Forms.GroupBox groupBox6;
		private System.Windows.Forms.Timer timerBumpSensor;
		private System.Windows.Forms.Label labelBump;
		private System.Windows.Forms.Button bumpStopButton;
		private System.Windows.Forms.Button bumpStartButton;
		private System.Windows.Forms.GroupBox groupBox7;
		private System.Windows.Forms.Button forwardButton;
		private System.Windows.Forms.Button button5;
		private System.Windows.Forms.Button easyLeftButton;
		private System.Windows.Forms.Button easyRightButton;
		private System.Windows.Forms.Button hardLeftButton;
		private System.Windows.Forms.Button hardRightButton;
		private System.Windows.Forms.Label label15;
		private System.Windows.Forms.Label label16;
		private System.Windows.Forms.Label label17;
		private System.Windows.Forms.Label label18;
		private System.Windows.Forms.Label label19;
		private System.Windows.Forms.Label label20;
		private System.Windows.Forms.Label label21;
		private System.Windows.Forms.Label label22;
		private System.Windows.Forms.Label label23;
		private System.Windows.Forms.Label label24;
		private System.Windows.Forms.Label label25;
		private System.Windows.Forms.Label label26;
		private System.Windows.Forms.Label label27;
		private System.Windows.Forms.Label label28;
		private System.Windows.Forms.Label label29;
		private System.Windows.Forms.GroupBox groupBox8;
		private System.Windows.Forms.Label label30;
		private System.Windows.Forms.NumericUpDown wayPointsNumberUpDown;
		private System.Windows.Forms.NumericUpDown timeWayPointsUpDown;
		private System.Windows.Forms.Label label31;
		private System.Windows.Forms.Button StartWayPointsFollowingbutton;
		private System.Windows.Forms.Button StopWayPointsFollowingbutton;
		private System.Windows.Forms.Timer timerWayPoints;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.Label label32;
		private System.Windows.Forms.NumericUpDown WayPointRefUpDown;


		private decimal _lastAngleRef = 0;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			robot = Robot.getInstance();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.labelMotorLeft = new System.Windows.Forms.Label();
			this.labelMotorRight = new System.Windows.Forms.Label();
			this.trackBarMotorLeft = new System.Windows.Forms.TrackBar();
			this.trackBarMotorRight = new System.Windows.Forms.TrackBar();
			this.buttonCalibrateAccel = new System.Windows.Forms.Button();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.label6 = new System.Windows.Forms.Label();
			this.accelDev1Label = new System.Windows.Forms.Label();
			this.accelDev2Label = new System.Windows.Forms.Label();
			this.ResetOdometry = new System.Windows.Forms.Button();
			this.StartOdometry = new System.Windows.Forms.Button();
			this.StopOdometry = new System.Windows.Forms.Button();
			this.label7 = new System.Windows.Forms.Label();
			this.label8 = new System.Windows.Forms.Label();
			this.odometryXLabel = new System.Windows.Forms.Label();
			this.odometryYLabel = new System.Windows.Forms.Label();
			this.timerAccelerometer = new System.Windows.Forms.Timer(this.components);
			this.label9 = new System.Windows.Forms.Label();
			this.label10 = new System.Windows.Forms.Label();
			this.accel1Label = new System.Windows.Forms.Label();
			this.accel2Label = new System.Windows.Forms.Label();
			this.label11 = new System.Windows.Forms.Label();
			this.label12 = new System.Windows.Forms.Label();
			this.vxLabel = new System.Windows.Forms.Label();
			this.vyLabel = new System.Windows.Forms.Label();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.label22 = new System.Windows.Forms.Label();
			this.label21 = new System.Windows.Forms.Label();
			this.label20 = new System.Windows.Forms.Label();
			this.label19 = new System.Windows.Forms.Label();
			this.label18 = new System.Windows.Forms.Label();
			this.label17 = new System.Windows.Forms.Label();
			this.label16 = new System.Windows.Forms.Label();
			this.label15 = new System.Windows.Forms.Label();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.label28 = new System.Windows.Forms.Label();
			this.label29 = new System.Windows.Forms.Label();
			this.label27 = new System.Windows.Forms.Label();
			this.label26 = new System.Windows.Forms.Label();
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.label24 = new System.Windows.Forms.Label();
			this.headingLabel = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.StopCompassButton = new System.Windows.Forms.Button();
			this.StartCompassButton = new System.Windows.Forms.Button();
			this.timerCompass = new System.Windows.Forms.Timer(this.components);
			this.groupBox4 = new System.Windows.Forms.GroupBox();
			this.label23 = new System.Windows.Forms.Label();
			this.digitalHeadingLabel = new System.Windows.Forms.Label();
			this.label13 = new System.Windows.Forms.Label();
			this.StopDigitalCompassButton = new System.Windows.Forms.Button();
			this.StartDigitalCompassButton = new System.Windows.Forms.Button();
			this.timerDigitalCompass = new System.Windows.Forms.Timer(this.components);
			this.timerGuiUpdate = new System.Windows.Forms.Timer(this.components);
			this.groupBox5 = new System.Windows.Forms.GroupBox();
			this.label14 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.desiredHeadingUpDown = new System.Windows.Forms.NumericUpDown();
			this.StopHeadingFollowButton = new System.Windows.Forms.Button();
			this.StartHeadingFollowButton = new System.Windows.Forms.Button();
			this.label25 = new System.Windows.Forms.Label();
			this.groupBox6 = new System.Windows.Forms.GroupBox();
			this.labelBump = new System.Windows.Forms.Label();
			this.bumpStopButton = new System.Windows.Forms.Button();
			this.bumpStartButton = new System.Windows.Forms.Button();
			this.timerBumpSensor = new System.Windows.Forms.Timer(this.components);
			this.groupBox7 = new System.Windows.Forms.GroupBox();
			this.button5 = new System.Windows.Forms.Button();
			this.hardRightButton = new System.Windows.Forms.Button();
			this.hardLeftButton = new System.Windows.Forms.Button();
			this.easyRightButton = new System.Windows.Forms.Button();
			this.easyLeftButton = new System.Windows.Forms.Button();
			this.forwardButton = new System.Windows.Forms.Button();
			this.groupBox8 = new System.Windows.Forms.GroupBox();
			this.label30 = new System.Windows.Forms.Label();
			this.wayPointsNumberUpDown = new System.Windows.Forms.NumericUpDown();
			this.timeWayPointsUpDown = new System.Windows.Forms.NumericUpDown();
			this.label31 = new System.Windows.Forms.Label();
			this.StartWayPointsFollowingbutton = new System.Windows.Forms.Button();
			this.StopWayPointsFollowingbutton = new System.Windows.Forms.Button();
			this.label32 = new System.Windows.Forms.Label();
			this.WayPointRefUpDown = new System.Windows.Forms.NumericUpDown();
			this.timerWayPoints = new System.Windows.Forms.Timer(this.components);
			((System.ComponentModel.ISupportInitialize)(this.trackBarMotorLeft)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.trackBarMotorRight)).BeginInit();
			this.groupBox1.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.groupBox3.SuspendLayout();
			this.groupBox4.SuspendLayout();
			this.groupBox5.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.desiredHeadingUpDown)).BeginInit();
			this.groupBox6.SuspendLayout();
			this.groupBox7.SuspendLayout();
			this.groupBox8.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.wayPointsNumberUpDown)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.timeWayPointsUpDown)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.WayPointRefUpDown)).BeginInit();
			this.SuspendLayout();
			// 
			// labelMotorLeft
			// 
			this.labelMotorLeft.Location = new System.Drawing.Point(8, 15);
			this.labelMotorLeft.Name = "labelMotorLeft";
			this.labelMotorLeft.Size = new System.Drawing.Size(104, 15);
			this.labelMotorLeft.TabIndex = 0;
			this.labelMotorLeft.Text = "Left Motor";
			this.labelMotorLeft.TextAlign = System.Drawing.ContentAlignment.TopCenter;
			// 
			// labelMotorRight
			// 
			this.labelMotorRight.Location = new System.Drawing.Point(120, 15);
			this.labelMotorRight.Name = "labelMotorRight";
			this.labelMotorRight.Size = new System.Drawing.Size(80, 15);
			this.labelMotorRight.TabIndex = 1;
			this.labelMotorRight.Text = "Right Motor";
			this.labelMotorRight.TextAlign = System.Drawing.ContentAlignment.TopCenter;
			// 
			// trackBarMotorLeft
			// 
			this.trackBarMotorLeft.Cursor = System.Windows.Forms.Cursors.Default;
			this.trackBarMotorLeft.LargeChange = 50;
			this.trackBarMotorLeft.Location = new System.Drawing.Point(40, 37);
			this.trackBarMotorLeft.Maximum = 500;
			this.trackBarMotorLeft.Name = "trackBarMotorLeft";
			this.trackBarMotorLeft.Orientation = System.Windows.Forms.Orientation.Vertical;
			this.trackBarMotorLeft.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.trackBarMotorLeft.Size = new System.Drawing.Size(45, 193);
			this.trackBarMotorLeft.SmallChange = 10;
			this.trackBarMotorLeft.TabIndex = 2;
			this.trackBarMotorLeft.TickFrequency = 10;
			this.trackBarMotorLeft.Scroll += new System.EventHandler(this.trackBarMotorLeft_Scroll);
			// 
			// trackBarMotorRight
			// 
			this.trackBarMotorRight.LargeChange = 50;
			this.trackBarMotorRight.Location = new System.Drawing.Point(144, 37);
			this.trackBarMotorRight.Maximum = 500;
			this.trackBarMotorRight.Name = "trackBarMotorRight";
			this.trackBarMotorRight.Orientation = System.Windows.Forms.Orientation.Vertical;
			this.trackBarMotorRight.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.trackBarMotorRight.Size = new System.Drawing.Size(45, 193);
			this.trackBarMotorRight.SmallChange = 10;
			this.trackBarMotorRight.TabIndex = 3;
			this.trackBarMotorRight.TickFrequency = 10;
			this.trackBarMotorRight.Scroll += new System.EventHandler(this.trackBarMotorRight_Scroll);
			// 
			// buttonCalibrateAccel
			// 
			this.buttonCalibrateAccel.Location = new System.Drawing.Point(96, 193);
			this.buttonCalibrateAccel.Name = "buttonCalibrateAccel";
			this.buttonCalibrateAccel.Size = new System.Drawing.Size(104, 30);
			this.buttonCalibrateAccel.TabIndex = 4;
			this.buttonCalibrateAccel.Text = "Calibrate Accelerometer";
			this.buttonCalibrateAccel.Click += new System.EventHandler(this.buttonCalibrateAccel_Click);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(72, 67);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(16, 15);
			this.label2.TabIndex = 7;
			this.label2.Text = "5";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(176, 67);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(16, 15);
			this.label3.TabIndex = 9;
			this.label3.Text = "5";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(8, 30);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(48, 15);
			this.label5.TabIndex = 10;
			this.label5.Text = "X Calib.";
			this.label5.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(168, 30);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(48, 15);
			this.label6.TabIndex = 11;
			this.label6.Text = "Y Calib.";
			this.label6.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// accelDev1Label
			// 
			this.accelDev1Label.Location = new System.Drawing.Point(72, 30);
			this.accelDev1Label.Name = "accelDev1Label";
			this.accelDev1Label.Size = new System.Drawing.Size(56, 15);
			this.accelDev1Label.TabIndex = 12;
			this.accelDev1Label.Text = "------";
			this.accelDev1Label.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// accelDev2Label
			// 
			this.accelDev2Label.Location = new System.Drawing.Point(240, 30);
			this.accelDev2Label.Name = "accelDev2Label";
			this.accelDev2Label.Size = new System.Drawing.Size(56, 15);
			this.accelDev2Label.TabIndex = 12;
			this.accelDev2Label.Text = "------";
			this.accelDev2Label.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// ResetOdometry
			// 
			this.ResetOdometry.Location = new System.Drawing.Point(216, 193);
			this.ResetOdometry.Name = "ResetOdometry";
			this.ResetOdometry.Size = new System.Drawing.Size(104, 32);
			this.ResetOdometry.TabIndex = 13;
			this.ResetOdometry.Text = "Reset Odometry";
			this.ResetOdometry.Click += new System.EventHandler(this.ResetOdometry_Click);
			// 
			// StartOdometry
			// 
			this.StartOdometry.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(192)), ((System.Byte)(255)), ((System.Byte)(192)));
			this.StartOdometry.Location = new System.Drawing.Point(96, 149);
			this.StartOdometry.Name = "StartOdometry";
			this.StartOdometry.Size = new System.Drawing.Size(104, 31);
			this.StartOdometry.TabIndex = 14;
			this.StartOdometry.Text = "Start Odometry";
			this.StartOdometry.Click += new System.EventHandler(this.StartOdometry_Click);
			// 
			// StopOdometry
			// 
			this.StopOdometry.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(128)), ((System.Byte)(128)));
			this.StopOdometry.Location = new System.Drawing.Point(216, 149);
			this.StopOdometry.Name = "StopOdometry";
			this.StopOdometry.Size = new System.Drawing.Size(104, 31);
			this.StopOdometry.TabIndex = 15;
			this.StopOdometry.Text = "Stop Odometry";
			this.StopOdometry.Click += new System.EventHandler(this.StopOdometry_Click);
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(16, 52);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(40, 24);
			this.label7.TabIndex = 16;
			this.label7.Text = "X";
			this.label7.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// label8
			// 
			this.label8.Location = new System.Drawing.Point(176, 52);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(40, 24);
			this.label8.TabIndex = 16;
			this.label8.Text = "Y";
			this.label8.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// odometryXLabel
			// 
			this.odometryXLabel.BackColor = System.Drawing.SystemColors.Info;
			this.odometryXLabel.ForeColor = System.Drawing.SystemColors.Highlight;
			this.odometryXLabel.Location = new System.Drawing.Point(72, 52);
			this.odometryXLabel.Name = "odometryXLabel";
			this.odometryXLabel.Size = new System.Drawing.Size(72, 16);
			this.odometryXLabel.TabIndex = 17;
			this.odometryXLabel.Text = "0";
			this.odometryXLabel.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// odometryYLabel
			// 
			this.odometryYLabel.BackColor = System.Drawing.SystemColors.Info;
			this.odometryYLabel.ForeColor = System.Drawing.SystemColors.Highlight;
			this.odometryYLabel.Location = new System.Drawing.Point(240, 52);
			this.odometryYLabel.Name = "odometryYLabel";
			this.odometryYLabel.Size = new System.Drawing.Size(72, 16);
			this.odometryYLabel.TabIndex = 17;
			this.odometryYLabel.Text = "0";
			this.odometryYLabel.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// timerAccelerometer
			// 
			this.timerAccelerometer.Tick += new System.EventHandler(this.timerAccelerometer_Tick);
			// 
			// label9
			// 
			this.label9.Location = new System.Drawing.Point(16, 111);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(40, 24);
			this.label9.TabIndex = 16;
			this.label9.Text = "Ax";
			this.label9.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// label10
			// 
			this.label10.Location = new System.Drawing.Point(176, 111);
			this.label10.Name = "label10";
			this.label10.Size = new System.Drawing.Size(40, 24);
			this.label10.TabIndex = 16;
			this.label10.Text = "Ay";
			this.label10.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// accel1Label
			// 
			this.accel1Label.BackColor = System.Drawing.SystemColors.Info;
			this.accel1Label.ForeColor = System.Drawing.SystemColors.Highlight;
			this.accel1Label.Location = new System.Drawing.Point(72, 111);
			this.accel1Label.Name = "accel1Label";
			this.accel1Label.Size = new System.Drawing.Size(72, 16);
			this.accel1Label.TabIndex = 17;
			this.accel1Label.Text = "0";
			this.accel1Label.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// accel2Label
			// 
			this.accel2Label.BackColor = System.Drawing.SystemColors.Info;
			this.accel2Label.ForeColor = System.Drawing.SystemColors.Highlight;
			this.accel2Label.Location = new System.Drawing.Point(240, 111);
			this.accel2Label.Name = "accel2Label";
			this.accel2Label.Size = new System.Drawing.Size(72, 16);
			this.accel2Label.TabIndex = 17;
			this.accel2Label.Text = "0";
			this.accel2Label.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// label11
			// 
			this.label11.Location = new System.Drawing.Point(16, 82);
			this.label11.Name = "label11";
			this.label11.Size = new System.Drawing.Size(40, 23);
			this.label11.TabIndex = 19;
			this.label11.Text = "Vx";
			this.label11.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// label12
			// 
			this.label12.Location = new System.Drawing.Point(176, 82);
			this.label12.Name = "label12";
			this.label12.Size = new System.Drawing.Size(40, 23);
			this.label12.TabIndex = 18;
			this.label12.Text = "Vy";
			this.label12.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// vxLabel
			// 
			this.vxLabel.BackColor = System.Drawing.SystemColors.Info;
			this.vxLabel.ForeColor = System.Drawing.SystemColors.Highlight;
			this.vxLabel.Location = new System.Drawing.Point(72, 82);
			this.vxLabel.Name = "vxLabel";
			this.vxLabel.Size = new System.Drawing.Size(72, 15);
			this.vxLabel.TabIndex = 21;
			this.vxLabel.Text = "0";
			this.vxLabel.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// vyLabel
			// 
			this.vyLabel.BackColor = System.Drawing.SystemColors.Info;
			this.vyLabel.ForeColor = System.Drawing.SystemColors.Highlight;
			this.vyLabel.Location = new System.Drawing.Point(240, 82);
			this.vyLabel.Name = "vyLabel";
			this.vyLabel.Size = new System.Drawing.Size(72, 15);
			this.vyLabel.TabIndex = 20;
			this.vyLabel.Text = "0";
			this.vyLabel.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.label22);
			this.groupBox1.Controls.Add(this.label21);
			this.groupBox1.Controls.Add(this.label20);
			this.groupBox1.Controls.Add(this.label19);
			this.groupBox1.Controls.Add(this.label18);
			this.groupBox1.Controls.Add(this.label17);
			this.groupBox1.Controls.Add(this.label16);
			this.groupBox1.Controls.Add(this.label15);
			this.groupBox1.Controls.Add(this.label9);
			this.groupBox1.Controls.Add(this.label10);
			this.groupBox1.Controls.Add(this.accel1Label);
			this.groupBox1.Controls.Add(this.accel2Label);
			this.groupBox1.Controls.Add(this.label11);
			this.groupBox1.Controls.Add(this.label12);
			this.groupBox1.Controls.Add(this.vxLabel);
			this.groupBox1.Controls.Add(this.vyLabel);
			this.groupBox1.Controls.Add(this.buttonCalibrateAccel);
			this.groupBox1.Controls.Add(this.label5);
			this.groupBox1.Controls.Add(this.label6);
			this.groupBox1.Controls.Add(this.accelDev1Label);
			this.groupBox1.Controls.Add(this.accelDev2Label);
			this.groupBox1.Controls.Add(this.ResetOdometry);
			this.groupBox1.Controls.Add(this.StartOdometry);
			this.groupBox1.Controls.Add(this.StopOdometry);
			this.groupBox1.Controls.Add(this.label7);
			this.groupBox1.Controls.Add(this.label8);
			this.groupBox1.Controls.Add(this.odometryXLabel);
			this.groupBox1.Controls.Add(this.odometryYLabel);
			this.groupBox1.Location = new System.Drawing.Point(240, 15);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(352, 238);
			this.groupBox1.TabIndex = 22;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Accelerometer Odometry";
			this.groupBox1.Enter += new System.EventHandler(this.groupBox1_Enter);
			// 
			// label22
			// 
			this.label22.Location = new System.Drawing.Point(312, 111);
			this.label22.Name = "label22";
			this.label22.Size = new System.Drawing.Size(44, 15);
			this.label22.TabIndex = 29;
			this.label22.Text = "m/s^2";
			// 
			// label21
			// 
			this.label21.Location = new System.Drawing.Point(144, 111);
			this.label21.Name = "label21";
			this.label21.Size = new System.Drawing.Size(44, 15);
			this.label21.TabIndex = 28;
			this.label21.Text = "m/s^2";
			// 
			// label20
			// 
			this.label20.Location = new System.Drawing.Point(312, 82);
			this.label20.Name = "label20";
			this.label20.Size = new System.Drawing.Size(24, 15);
			this.label20.TabIndex = 27;
			this.label20.Text = "m/s";
			// 
			// label19
			// 
			this.label19.Location = new System.Drawing.Point(144, 82);
			this.label19.Name = "label19";
			this.label19.Size = new System.Drawing.Size(24, 15);
			this.label19.TabIndex = 26;
			this.label19.Text = "m/s";
			// 
			// label18
			// 
			this.label18.Location = new System.Drawing.Point(312, 52);
			this.label18.Name = "label18";
			this.label18.Size = new System.Drawing.Size(16, 15);
			this.label18.TabIndex = 25;
			this.label18.Text = "m";
			// 
			// label17
			// 
			this.label17.Location = new System.Drawing.Point(144, 52);
			this.label17.Name = "label17";
			this.label17.Size = new System.Drawing.Size(16, 15);
			this.label17.TabIndex = 24;
			this.label17.Text = "m";
			// 
			// label16
			// 
			this.label16.Location = new System.Drawing.Point(296, 30);
			this.label16.Name = "label16";
			this.label16.Size = new System.Drawing.Size(16, 15);
			this.label16.TabIndex = 23;
			this.label16.Text = "V";
			// 
			// label15
			// 
			this.label15.Location = new System.Drawing.Point(128, 30);
			this.label15.Name = "label15";
			this.label15.Size = new System.Drawing.Size(16, 15);
			this.label15.TabIndex = 22;
			this.label15.Text = "V";
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.label28);
			this.groupBox2.Controls.Add(this.label29);
			this.groupBox2.Controls.Add(this.label27);
			this.groupBox2.Controls.Add(this.label26);
			this.groupBox2.Controls.Add(this.labelMotorRight);
			this.groupBox2.Controls.Add(this.trackBarMotorLeft);
			this.groupBox2.Controls.Add(this.trackBarMotorRight);
			this.groupBox2.Controls.Add(this.label2);
			this.groupBox2.Controls.Add(this.label3);
			this.groupBox2.Controls.Add(this.labelMotorLeft);
			this.groupBox2.Location = new System.Drawing.Point(16, 15);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(216, 238);
			this.groupBox2.TabIndex = 23;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Motors";
			// 
			// label28
			// 
			this.label28.Location = new System.Drawing.Point(176, 45);
			this.label28.Name = "label28";
			this.label28.Size = new System.Drawing.Size(24, 21);
			this.label28.TabIndex = 13;
			this.label28.Text = "5 V";
			// 
			// label29
			// 
			this.label29.Location = new System.Drawing.Point(72, 45);
			this.label29.Name = "label29";
			this.label29.Size = new System.Drawing.Size(24, 21);
			this.label29.TabIndex = 12;
			this.label29.Text = "5 V";
			// 
			// label27
			// 
			this.label27.Location = new System.Drawing.Point(176, 208);
			this.label27.Name = "label27";
			this.label27.Size = new System.Drawing.Size(24, 21);
			this.label27.TabIndex = 11;
			this.label27.Text = "0 V";
			// 
			// label26
			// 
			this.label26.Location = new System.Drawing.Point(72, 208);
			this.label26.Name = "label26";
			this.label26.Size = new System.Drawing.Size(24, 21);
			this.label26.TabIndex = 10;
			this.label26.Text = "0 V";
			// 
			// groupBox3
			// 
			this.groupBox3.Controls.Add(this.label24);
			this.groupBox3.Controls.Add(this.headingLabel);
			this.groupBox3.Controls.Add(this.label1);
			this.groupBox3.Controls.Add(this.StopCompassButton);
			this.groupBox3.Controls.Add(this.StartCompassButton);
			this.groupBox3.Location = new System.Drawing.Point(600, 15);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(256, 111);
			this.groupBox3.TabIndex = 24;
			this.groupBox3.TabStop = false;
			this.groupBox3.Text = "Compass (Analog)";
			// 
			// label24
			// 
			this.label24.Location = new System.Drawing.Point(208, 37);
			this.label24.Name = "label24";
			this.label24.Size = new System.Drawing.Size(8, 15);
			this.label24.TabIndex = 30;
			this.label24.Text = "";
			// 
			// headingLabel
			// 
			this.headingLabel.BackColor = System.Drawing.SystemColors.Info;
			this.headingLabel.ForeColor = System.Drawing.SystemColors.Highlight;
			this.headingLabel.Location = new System.Drawing.Point(136, 30);
			this.headingLabel.Name = "headingLabel";
			this.headingLabel.Size = new System.Drawing.Size(72, 15);
			this.headingLabel.TabIndex = 18;
			this.headingLabel.Text = "0";
			this.headingLabel.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(24, 30);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(80, 15);
			this.label1.TabIndex = 0;
			this.label1.Text = "Heading";
			// 
			// StopCompassButton
			// 
			this.StopCompassButton.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(128)), ((System.Byte)(128)));
			this.StopCompassButton.Location = new System.Drawing.Point(136, 67);
			this.StopCompassButton.Name = "StopCompassButton";
			this.StopCompassButton.Size = new System.Drawing.Size(104, 31);
			this.StopCompassButton.TabIndex = 23;
			this.StopCompassButton.Text = "Stop Compass";
			this.StopCompassButton.Click += new System.EventHandler(this.StopCompassButton_Click);
			// 
			// StartCompassButton
			// 
			this.StartCompassButton.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(192)), ((System.Byte)(255)), ((System.Byte)(192)));
			this.StartCompassButton.Location = new System.Drawing.Point(16, 67);
			this.StartCompassButton.Name = "StartCompassButton";
			this.StartCompassButton.Size = new System.Drawing.Size(104, 31);
			this.StartCompassButton.TabIndex = 22;
			this.StartCompassButton.Text = "Start Compass";
			this.StartCompassButton.Click += new System.EventHandler(this.StartCompassButton_Click);
			// 
			// timerCompass
			// 
			this.timerCompass.Interval = 10;
			this.timerCompass.Tick += new System.EventHandler(this.timerCompass_Tick);
			// 
			// groupBox4
			// 
			this.groupBox4.Controls.Add(this.label23);
			this.groupBox4.Controls.Add(this.digitalHeadingLabel);
			this.groupBox4.Controls.Add(this.label13);
			this.groupBox4.Controls.Add(this.StopDigitalCompassButton);
			this.groupBox4.Controls.Add(this.StartDigitalCompassButton);
			this.groupBox4.Location = new System.Drawing.Point(600, 141);
			this.groupBox4.Name = "groupBox4";
			this.groupBox4.Size = new System.Drawing.Size(256, 112);
			this.groupBox4.TabIndex = 25;
			this.groupBox4.TabStop = false;
			this.groupBox4.Text = "Compass (Digital)";
			// 
			// label23
			// 
			this.label23.Location = new System.Drawing.Point(208, 30);
			this.label23.Name = "label23";
			this.label23.Size = new System.Drawing.Size(8, 15);
			this.label23.TabIndex = 29;
			this.label23.Text = "";
			// 
			// digitalHeadingLabel
			// 
			this.digitalHeadingLabel.BackColor = System.Drawing.SystemColors.Info;
			this.digitalHeadingLabel.ForeColor = System.Drawing.SystemColors.Highlight;
			this.digitalHeadingLabel.Location = new System.Drawing.Point(128, 30);
			this.digitalHeadingLabel.Name = "digitalHeadingLabel";
			this.digitalHeadingLabel.Size = new System.Drawing.Size(80, 15);
			this.digitalHeadingLabel.TabIndex = 27;
			this.digitalHeadingLabel.Text = "0";
			this.digitalHeadingLabel.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// label13
			// 
			this.label13.Location = new System.Drawing.Point(16, 30);
			this.label13.Name = "label13";
			this.label13.Size = new System.Drawing.Size(80, 15);
			this.label13.TabIndex = 26;
			this.label13.Text = "Heading";
			// 
			// StopDigitalCompassButton
			// 
			this.StopDigitalCompassButton.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(128)), ((System.Byte)(128)));
			this.StopDigitalCompassButton.Location = new System.Drawing.Point(136, 67);
			this.StopDigitalCompassButton.Name = "StopDigitalCompassButton";
			this.StopDigitalCompassButton.Size = new System.Drawing.Size(104, 31);
			this.StopDigitalCompassButton.TabIndex = 25;
			this.StopDigitalCompassButton.Text = "Stop Compass";
			this.StopDigitalCompassButton.Click += new System.EventHandler(this.StopDigitalCompassButton_Click);
			// 
			// StartDigitalCompassButton
			// 
			this.StartDigitalCompassButton.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(192)), ((System.Byte)(255)), ((System.Byte)(192)));
			this.StartDigitalCompassButton.Location = new System.Drawing.Point(16, 67);
			this.StartDigitalCompassButton.Name = "StartDigitalCompassButton";
			this.StartDigitalCompassButton.Size = new System.Drawing.Size(104, 31);
			this.StartDigitalCompassButton.TabIndex = 24;
			this.StartDigitalCompassButton.Text = "Start Compass";
			this.StartDigitalCompassButton.Click += new System.EventHandler(this.StartDigitalCompassButton_Click);
			// 
			// timerDigitalCompass
			// 
			this.timerDigitalCompass.Interval = 10;
			this.timerDigitalCompass.Tick += new System.EventHandler(this.timerDigitalCompass_Tick);
			// 
			// timerGuiUpdate
			// 
			this.timerGuiUpdate.Enabled = true;
			this.timerGuiUpdate.Interval = 10;
			this.timerGuiUpdate.Tick += new System.EventHandler(this.timerGuiUpdate_Tick);
			// 
			// groupBox5
			// 
			this.groupBox5.Controls.Add(this.label14);
			this.groupBox5.Controls.Add(this.label4);
			this.groupBox5.Controls.Add(this.desiredHeadingUpDown);
			this.groupBox5.Controls.Add(this.StopHeadingFollowButton);
			this.groupBox5.Controls.Add(this.StartHeadingFollowButton);
			this.groupBox5.Controls.Add(this.label25);
			this.groupBox5.Location = new System.Drawing.Point(600, 260);
			this.groupBox5.Name = "groupBox5";
			this.groupBox5.Size = new System.Drawing.Size(248, 119);
			this.groupBox5.TabIndex = 26;
			this.groupBox5.TabStop = false;
			this.groupBox5.Text = "Heading Following Behavior";
			// 
			// label14
			// 
			this.label14.Location = new System.Drawing.Point(16, 22);
			this.label14.Name = "label14";
			this.label14.Size = new System.Drawing.Size(216, 22);
			this.label14.TabIndex = 30;
			this.label14.Text = "Digital Compass should be started first!!";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(16, 45);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(96, 22);
			this.label4.TabIndex = 29;
			this.label4.Text = "Desired Heading";
			// 
			// desiredHeadingUpDown
			// 
			this.desiredHeadingUpDown.Enabled = false;
			this.desiredHeadingUpDown.Location = new System.Drawing.Point(120, 45);
			this.desiredHeadingUpDown.Maximum = new System.Decimal(new int[] {
																				 360,
																				 0,
																				 0,
																				 0});
			this.desiredHeadingUpDown.Minimum = new System.Decimal(new int[] {
																				 1,
																				 0,
																				 0,
																				 -2147483648});
			this.desiredHeadingUpDown.Name = "desiredHeadingUpDown";
			this.desiredHeadingUpDown.Size = new System.Drawing.Size(88, 20);
			this.desiredHeadingUpDown.TabIndex = 28;
			this.desiredHeadingUpDown.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.desiredHeadingUpDown.ValueChanged += new System.EventHandler(this.desiredHeadingUpDown_ValueChanged);
			// 
			// StopHeadingFollowButton
			// 
			this.StopHeadingFollowButton.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(128)), ((System.Byte)(128)));
			this.StopHeadingFollowButton.Location = new System.Drawing.Point(128, 74);
			this.StopHeadingFollowButton.Name = "StopHeadingFollowButton";
			this.StopHeadingFollowButton.Size = new System.Drawing.Size(104, 32);
			this.StopHeadingFollowButton.TabIndex = 27;
			this.StopHeadingFollowButton.Text = "Stop Following";
			this.StopHeadingFollowButton.Click += new System.EventHandler(this.button1_Click);
			// 
			// StartHeadingFollowButton
			// 
			this.StartHeadingFollowButton.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(192)), ((System.Byte)(255)), ((System.Byte)(192)));
			this.StartHeadingFollowButton.Location = new System.Drawing.Point(16, 74);
			this.StartHeadingFollowButton.Name = "StartHeadingFollowButton";
			this.StartHeadingFollowButton.Size = new System.Drawing.Size(104, 32);
			this.StartHeadingFollowButton.TabIndex = 26;
			this.StartHeadingFollowButton.Text = "Start Following";
			this.StartHeadingFollowButton.Click += new System.EventHandler(this.StartHeadingFollowButton_Click);
			// 
			// label25
			// 
			this.label25.Location = new System.Drawing.Point(208, 45);
			this.label25.Name = "label25";
			this.label25.Size = new System.Drawing.Size(8, 14);
			this.label25.TabIndex = 30;
			this.label25.Text = "";
			// 
			// groupBox6
			// 
			this.groupBox6.Controls.Add(this.labelBump);
			this.groupBox6.Controls.Add(this.bumpStopButton);
			this.groupBox6.Controls.Add(this.bumpStartButton);
			this.groupBox6.Location = new System.Drawing.Point(240, 260);
			this.groupBox6.Name = "groupBox6";
			this.groupBox6.Size = new System.Drawing.Size(352, 119);
			this.groupBox6.TabIndex = 27;
			this.groupBox6.TabStop = false;
			this.groupBox6.Text = "Bump Detector";
			// 
			// labelBump
			// 
			this.labelBump.BackColor = System.Drawing.Color.Gray;
			this.labelBump.Font = new System.Drawing.Font("Tahoma", 18F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelBump.ForeColor = System.Drawing.Color.Silver;
			this.labelBump.Location = new System.Drawing.Point(104, 22);
			this.labelBump.Name = "labelBump";
			this.labelBump.Size = new System.Drawing.Size(216, 37);
			this.labelBump.TabIndex = 30;
			this.labelBump.Text = "inactive";
			this.labelBump.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// bumpStopButton
			// 
			this.bumpStopButton.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(128)), ((System.Byte)(128)));
			this.bumpStopButton.Location = new System.Drawing.Point(216, 74);
			this.bumpStopButton.Name = "bumpStopButton";
			this.bumpStopButton.Size = new System.Drawing.Size(104, 32);
			this.bumpStopButton.TabIndex = 29;
			this.bumpStopButton.Text = "Stop Detector";
			this.bumpStopButton.Click += new System.EventHandler(this.bumpStopButton_Click);
			// 
			// bumpStartButton
			// 
			this.bumpStartButton.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(192)), ((System.Byte)(255)), ((System.Byte)(192)));
			this.bumpStartButton.Location = new System.Drawing.Point(104, 74);
			this.bumpStartButton.Name = "bumpStartButton";
			this.bumpStartButton.Size = new System.Drawing.Size(104, 32);
			this.bumpStartButton.TabIndex = 28;
			this.bumpStartButton.Text = "Start Detector";
			this.bumpStartButton.Click += new System.EventHandler(this.bumpStartButton_Click);
			// 
			// timerBumpSensor
			// 
			this.timerBumpSensor.Tick += new System.EventHandler(this.timerBumpSensor_Tick);
			// 
			// groupBox7
			// 
			this.groupBox7.Controls.Add(this.button5);
			this.groupBox7.Controls.Add(this.hardRightButton);
			this.groupBox7.Controls.Add(this.hardLeftButton);
			this.groupBox7.Controls.Add(this.easyRightButton);
			this.groupBox7.Controls.Add(this.easyLeftButton);
			this.groupBox7.Controls.Add(this.forwardButton);
			this.groupBox7.Location = new System.Drawing.Point(16, 260);
			this.groupBox7.Name = "groupBox7";
			this.groupBox7.Size = new System.Drawing.Size(216, 119);
			this.groupBox7.TabIndex = 28;
			this.groupBox7.TabStop = false;
			this.groupBox7.Text = "Manual Robot Control";
			// 
			// button5
			// 
			this.button5.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(128)), ((System.Byte)(128)));
			this.button5.Location = new System.Drawing.Point(88, 82);
			this.button5.Name = "button5";
			this.button5.Size = new System.Drawing.Size(40, 29);
			this.button5.TabIndex = 5;
			this.button5.Text = "STOP";
			this.button5.Click += new System.EventHandler(this.button5_Click);
			// 
			// hardRightButton
			// 
			this.hardRightButton.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(192)), ((System.Byte)(128)));
			this.hardRightButton.Location = new System.Drawing.Point(136, 82);
			this.hardRightButton.Name = "hardRightButton";
			this.hardRightButton.Size = new System.Drawing.Size(72, 22);
			this.hardRightButton.TabIndex = 4;
			this.hardRightButton.Text = "Hard Right";
			this.hardRightButton.Click += new System.EventHandler(this.hardRightButton_Click);
			// 
			// hardLeftButton
			// 
			this.hardLeftButton.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(192)), ((System.Byte)(128)));
			this.hardLeftButton.Location = new System.Drawing.Point(8, 82);
			this.hardLeftButton.Name = "hardLeftButton";
			this.hardLeftButton.Size = new System.Drawing.Size(72, 22);
			this.hardLeftButton.TabIndex = 3;
			this.hardLeftButton.Text = "Hard Left";
			this.hardLeftButton.Click += new System.EventHandler(this.hardLeftButton_Click);
			// 
			// easyRightButton
			// 
			this.easyRightButton.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(255)), ((System.Byte)(128)));
			this.easyRightButton.Location = new System.Drawing.Point(120, 52);
			this.easyRightButton.Name = "easyRightButton";
			this.easyRightButton.Size = new System.Drawing.Size(72, 22);
			this.easyRightButton.TabIndex = 2;
			this.easyRightButton.Text = "Easy Right";
			this.easyRightButton.Click += new System.EventHandler(this.easyRightButton_Click);
			// 
			// easyLeftButton
			// 
			this.easyLeftButton.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(255)), ((System.Byte)(128)));
			this.easyLeftButton.Location = new System.Drawing.Point(24, 52);
			this.easyLeftButton.Name = "easyLeftButton";
			this.easyLeftButton.Size = new System.Drawing.Size(72, 22);
			this.easyLeftButton.TabIndex = 1;
			this.easyLeftButton.Text = "Easy Left";
			this.easyLeftButton.Click += new System.EventHandler(this.easyLeftButton_Click);
			// 
			// forwardButton
			// 
			this.forwardButton.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(192)), ((System.Byte)(255)), ((System.Byte)(192)));
			this.forwardButton.Location = new System.Drawing.Point(80, 22);
			this.forwardButton.Name = "forwardButton";
			this.forwardButton.Size = new System.Drawing.Size(64, 23);
			this.forwardButton.TabIndex = 0;
			this.forwardButton.Text = "Forward";
			this.forwardButton.Click += new System.EventHandler(this.forwardButton_Click);
			// 
			// groupBox8
			// 
			this.groupBox8.Controls.Add(this.label30);
			this.groupBox8.Controls.Add(this.wayPointsNumberUpDown);
			this.groupBox8.Controls.Add(this.timeWayPointsUpDown);
			this.groupBox8.Controls.Add(this.label31);
			this.groupBox8.Controls.Add(this.StartWayPointsFollowingbutton);
			this.groupBox8.Controls.Add(this.StopWayPointsFollowingbutton);
			this.groupBox8.Controls.Add(this.label32);
			this.groupBox8.Controls.Add(this.WayPointRefUpDown);
			this.groupBox8.Location = new System.Drawing.Point(600, 392);
			this.groupBox8.Name = "groupBox8";
			this.groupBox8.Size = new System.Drawing.Size(248, 144);
			this.groupBox8.TabIndex = 29;
			this.groupBox8.TabStop = false;
			this.groupBox8.Text = "Shape Following Behavior";
			// 
			// label30
			// 
			this.label30.Location = new System.Drawing.Point(8, 24);
			this.label30.Name = "label30";
			this.label30.Size = new System.Drawing.Size(136, 22);
			this.label30.TabIndex = 29;
			this.label30.Text = "Number of Shape Points:";
			// 
			// wayPointsNumberUpDown
			// 
			this.wayPointsNumberUpDown.Location = new System.Drawing.Point(152, 24);
			this.wayPointsNumberUpDown.Minimum = new System.Decimal(new int[] {
																				  2,
																				  0,
																				  0,
																				  0});
			this.wayPointsNumberUpDown.Name = "wayPointsNumberUpDown";
			this.wayPointsNumberUpDown.Size = new System.Drawing.Size(88, 20);
			this.wayPointsNumberUpDown.TabIndex = 28;
			this.wayPointsNumberUpDown.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.wayPointsNumberUpDown.Value = new System.Decimal(new int[] {
																				4,
																				0,
																				0,
																				0});
			// 
			// timeWayPointsUpDown
			// 
			this.timeWayPointsUpDown.Location = new System.Drawing.Point(152, 48);
			this.timeWayPointsUpDown.Maximum = new System.Decimal(new int[] {
																				60,
																				0,
																				0,
																				0});
			this.timeWayPointsUpDown.Minimum = new System.Decimal(new int[] {
																				1,
																				0,
																				0,
																				0});
			this.timeWayPointsUpDown.Name = "timeWayPointsUpDown";
			this.timeWayPointsUpDown.Size = new System.Drawing.Size(88, 20);
			this.timeWayPointsUpDown.TabIndex = 28;
			this.timeWayPointsUpDown.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.timeWayPointsUpDown.Value = new System.Decimal(new int[] {
																			  2,
																			  0,
																			  0,
																			  0});
			this.timeWayPointsUpDown.ValueChanged += new System.EventHandler(this.timeWayPointsUpDown_ValueChanged);
			// 
			// label31
			// 
			this.label31.Location = new System.Drawing.Point(8, 48);
			this.label31.Name = "label31";
			this.label31.Size = new System.Drawing.Size(152, 22);
			this.label31.TabIndex = 29;
			this.label31.Text = "Time between Shape Points:";
			// 
			// StartWayPointsFollowingbutton
			// 
			this.StartWayPointsFollowingbutton.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(192)), ((System.Byte)(255)), ((System.Byte)(192)));
			this.StartWayPointsFollowingbutton.Location = new System.Drawing.Point(16, 104);
			this.StartWayPointsFollowingbutton.Name = "StartWayPointsFollowingbutton";
			this.StartWayPointsFollowingbutton.Size = new System.Drawing.Size(104, 32);
			this.StartWayPointsFollowingbutton.TabIndex = 26;
			this.StartWayPointsFollowingbutton.Text = "Start Following";
			this.StartWayPointsFollowingbutton.Click += new System.EventHandler(this.StartWayPointsFollowingbutton_Click);
			// 
			// StopWayPointsFollowingbutton
			// 
			this.StopWayPointsFollowingbutton.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(128)), ((System.Byte)(128)));
			this.StopWayPointsFollowingbutton.Location = new System.Drawing.Point(136, 104);
			this.StopWayPointsFollowingbutton.Name = "StopWayPointsFollowingbutton";
			this.StopWayPointsFollowingbutton.Size = new System.Drawing.Size(104, 32);
			this.StopWayPointsFollowingbutton.TabIndex = 27;
			this.StopWayPointsFollowingbutton.Text = "Stop Following";
			this.StopWayPointsFollowingbutton.Click += new System.EventHandler(this.StopWayPointsFollowingbutton_Click);
			// 
			// label32
			// 
			this.label32.Location = new System.Drawing.Point(8, 80);
			this.label32.Name = "label32";
			this.label32.Size = new System.Drawing.Size(96, 22);
			this.label32.TabIndex = 29;
			this.label32.Text = "Desired Heading";
			// 
			// WayPointRefUpDown
			// 
			this.WayPointRefUpDown.Location = new System.Drawing.Point(152, 80);
			this.WayPointRefUpDown.Maximum = new System.Decimal(new int[] {
																			  361,
																			  0,
																			  0,
																			  0});
			this.WayPointRefUpDown.Minimum = new System.Decimal(new int[] {
																			  1,
																			  0,
																			  0,
																			  -2147483648});
			this.WayPointRefUpDown.Name = "WayPointRefUpDown";
			this.WayPointRefUpDown.Size = new System.Drawing.Size(88, 20);
			this.WayPointRefUpDown.TabIndex = 28;
			this.WayPointRefUpDown.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.WayPointRefUpDown.ValueChanged += new System.EventHandler(this.WayPointRefUpDown_ValueChanged);
			// 
			// timerWayPoints
			// 
			this.timerWayPoints.Interval = 2000;
			this.timerWayPoints.Tick += new System.EventHandler(this.timerWayPoints_Tick);
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(864, 542);
			this.Controls.Add(this.groupBox8);
			this.Controls.Add(this.groupBox7);
			this.Controls.Add(this.groupBox6);
			this.Controls.Add(this.groupBox5);
			this.Controls.Add(this.groupBox4);
			this.Controls.Add(this.groupBox3);
			this.Controls.Add(this.groupBox2);
			this.Controls.Add(this.groupBox1);
			this.Name = "MainForm";
			this.Text = "Rasteirinho: Accelerometer & Compass Test Program";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.MainForm_Closing);
			((System.ComponentModel.ISupportInitialize)(this.trackBarMotorLeft)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.trackBarMotorRight)).EndInit();
			this.groupBox1.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.groupBox3.ResumeLayout(false);
			this.groupBox4.ResumeLayout(false);
			this.groupBox5.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.desiredHeadingUpDown)).EndInit();
			this.groupBox6.ResumeLayout(false);
			this.groupBox7.ResumeLayout(false);
			this.groupBox8.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.wayPointsNumberUpDown)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.timeWayPointsUpDown)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.WayPointRefUpDown)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion


		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.EnableVisualStyles();
			Application.DoEvents();
			Application.Run(new MainForm());
		}

		private void trackBarMotorLeft_Scroll(object sender, System.EventArgs e)
		{
			robot.setLeftMotor(Convert.ToDouble(trackBarMotorLeft.Value) / 100);
		}

		private void trackBarMotorRight_Scroll(object sender, System.EventArgs e)
		{
			robot.setRightMotor(Convert.ToDouble(trackBarMotorRight.Value) / 100);
		}

		private void MainForm_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			robot.Halt();
		}

		private void buttonCalibrateAccel_Click(object sender, System.EventArgs e)
		{
			new FormCalibrate().ShowDialog();

			accelDev1Label.Text = Math.Round( Robot.getInstance().getAccel1CalibValue(), 4).ToString();
			accelDev2Label.Text = Math.Round( Robot.getInstance().getAccel2CalibValue(), 4).ToString();
		}

		private void timerAccelerometer_Tick(object sender, System.EventArgs e)
		{
		
			Robot.getInstance().odometryStep();

			//refresh display values:
			odometryXLabel.Text = Math.Round(Robot.getInstance().getOdometryX(), 4).ToString();
			odometryYLabel.Text = Math.Round(Robot.getInstance().getOdometryY(), 4).ToString();

			vxLabel.Text = Math.Round(Robot.getInstance().getVx(), 4).ToString();
			vyLabel.Text = Math.Round(Robot.getInstance().getVy(), 4).ToString();

			accel1Label.Text = Math.Round(Robot.getInstance().getAccel1ActualValue(), 4 ).ToString();
			accel2Label.Text = Math.Round(Robot.getInstance().getAccel2ActualValue(), 4 ).ToString();
		}

		private void StartOdometry_Click(object sender, System.EventArgs e)
		{
			timerAccelerometer.Enabled = true;
		}

		private void StopOdometry_Click(object sender, System.EventArgs e)
		{
			timerAccelerometer.Enabled = false;
		}

		private void ResetOdometry_Click(object sender, System.EventArgs e)
		{
			Robot.getInstance().resetOdometry();

			odometryXLabel.Text = "0";
			odometryYLabel.Text = "0";

			vxLabel.Text = "0";
			vyLabel.Text = "0";

			accel1Label.Text = "0";
			accel2Label.Text = "0";
		}

		private void timerCompass_Tick(object sender, System.EventArgs e)
		{
			Robot.getInstance().compassRead();

			headingLabel.Text = Math.Round(Robot.getInstance().getHeading(), 4).ToString();
		}

		private void StartCompassButton_Click(object sender, System.EventArgs e)
		{
			timerCompass.Enabled = true;
		}

		private void StopCompassButton_Click(object sender, System.EventArgs e)
		{
			timerCompass.Enabled = false;
		}

		private void timerDigitalCompass_Tick(object sender, System.EventArgs e)
		{
			digitalHeadingLabel.Text = Math.Round(Robot.getInstance().getDigitalHeading(), 4).ToString();

		}

		private void StartDigitalCompassButton_Click(object sender, System.EventArgs e)
		{
			timerDigitalCompass.Enabled = true;
			Robot.getInstance().digitalCompassStart();
		}

		private void StopDigitalCompassButton_Click(object sender, System.EventArgs e)
		{
			timerDigitalCompass.Enabled = false;
			Robot.getInstance().stopHeadingFollower();
			Robot.getInstance().digitalCompassStop();
		}

		private void buttonCalibCompass_Click(object sender, System.EventArgs e)
		{
		
		}

		private void timerGuiUpdate_Tick(object sender, System.EventArgs e)
		{
			
			double leftMotor = Robot.getInstance().getLeftMotor();
			double rightMotor = Robot.getInstance().getRightMotor();

			trackBarMotorLeft.Value = (int)Math.Round(leftMotor * 100);
			trackBarMotorRight.Value = (int)Math.Round(rightMotor * 100);
			
		}

		private void groupBox1_Enter(object sender, System.EventArgs e)
		{
		
		}

		private void StartHeadingFollowButton_Click(object sender, System.EventArgs e)
		{
			decimal currentHeading = (decimal)Robot.getInstance().getDigitalHeading();
			desiredHeadingUpDown.Value = currentHeading;
			desiredHeadingUpDown.Enabled = true;
			Robot.getInstance().setDesiredHeading((int)currentHeading);
			Robot.getInstance().startHeadingFollower();
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			Robot.getInstance().stopHeadingFollower();
			desiredHeadingUpDown.Enabled = false;
		}

		private void desiredHeadingUpDown_ValueChanged(object sender, System.EventArgs e)
		{
			decimal val = desiredHeadingUpDown.Value;

			if(val == 360)
			{
				desiredHeadingUpDown.Value = 0;
				val = 0;
			}
			else if(val == -1)
			{
				desiredHeadingUpDown.Value = 359;
				val = 359;
			}

			Robot.getInstance().setDesiredHeading((int)val);
		}

		private void timerBumpSensor_Tick(object sender, System.EventArgs e)
		{
			if(Robot.getInstance().isBumped())
			{
				labelBump.Text = "BUMP!!";
				labelBump.BackColor = Color.Red;
			}
			else
			{
				labelBump.Text = "OK";
				labelBump.BackColor = Color.Green;
			}
		}

		private void bumpStartButton_Click(object sender, System.EventArgs e)
		{
			labelBump.ForeColor = Color.Black;
			labelBump.Text = "active";
			Robot.getInstance().startBumpDetect();
			timerBumpSensor.Enabled = true;
		}

		private void bumpStopButton_Click(object sender, System.EventArgs e)
		{
			timerBumpSensor.Enabled = false;
			labelBump.ForeColor = Color.DarkGray;
			labelBump.BackColor = Color.Gray;
			labelBump.Text = "inactive";
			Robot.getInstance().stopBumpDetect();
		}

		private void forwardButton_Click(object sender, System.EventArgs e)
		{
			Robot.getInstance().setLeftMotor(2);
			Robot.getInstance().setRightMotor(2);
		}

		private void easyLeftButton_Click(object sender, System.EventArgs e)
		{
			Robot.getInstance().setLeftMotor(1.5);
			Robot.getInstance().setRightMotor(2);		
		}

		private void easyRightButton_Click(object sender, System.EventArgs e)
		{
			Robot.getInstance().setLeftMotor(2);
			Robot.getInstance().setRightMotor(1.5);
		}

		private void hardLeftButton_Click(object sender, System.EventArgs e)
		{
			Robot.getInstance().setLeftMotor(0);
			Robot.getInstance().setRightMotor(2);
		}

		private void hardRightButton_Click(object sender, System.EventArgs e)
		{
			Robot.getInstance().setLeftMotor(2);
			Robot.getInstance().setRightMotor(0);
		}

		private void button5_Click(object sender, System.EventArgs e)
		{
			Robot.getInstance().stop();
		}

		private void StartWayPointsFollowingbutton_Click(object sender, System.EventArgs e)
		{
			_lastAngleRef = (decimal)Robot.getInstance().getDigitalHeading();

			timerWayPoints.Enabled = true;

			Robot.getInstance().setDesiredHeading((int)_lastAngleRef);
			Robot.getInstance().startHeadingFollower();



		}

		private void timerWayPoints_Tick(object sender, System.EventArgs e)
		{
			//vamos buscar o numero de pontos e calculamos o angulo de incremento

			decimal angleInc = 360 / wayPointsNumberUpDown.Value;

			//ir buscar a orientao anterior e somar o angulo de incremento

			_lastAngleRef += angleInc;

			_lastAngleRef = _lastAngleRef % 360;

			WayPointRefUpDown.Value = _lastAngleRef;
			
			Robot.getInstance().setDesiredHeading((int)_lastAngleRef);
			Robot.getInstance().startHeadingFollower();

		}

		private void timeWayPointsUpDown_ValueChanged(object sender, System.EventArgs e)
		{
			timerWayPoints.Interval = (int)(1000 * timeWayPointsUpDown.Value);
		}

		private void StopWayPointsFollowingbutton_Click(object sender, System.EventArgs e)
		{
			timerWayPoints.Enabled = false;
			Robot.getInstance().stopHeadingFollower();

		}

		private void WayPointRefUpDown_ValueChanged(object sender, System.EventArgs e)
		{
			_lastAngleRef = WayPointRefUpDown.Value;
		}





	}
}
