using System;

namespace accel_compass
{
	/// <summary>
	/// Summary description for PIDcontroller.
	/// </summary>
	public class PIcontroller
	{

		//valores andar em frente:
//		private double kp = 0.015;
//		private double ki = 0.00005;//0.00005;
//		private double kd = -0.1;


		//valores quadrado
		private double kp = 0.007;
		private double ki = 0.00005;//0.00005;
		private double kd = -0.3;

		private double intLimit = 1.5; //em volts
		private double maxModulus = 1.5;

		private double intForgetDelta = 3;

		private double output = 0;
		private double integrator = 0;

		public PIcontroller()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		public void setKp(double val)
		{
			kp = val;
		}

		public void setKi(double val)
		{
			ki = val;
		}

		public double updateFilter(double error)
		{
			double oldOutput = output;

			if(Math.Abs(error) < intForgetDelta)
			{
				integrator = 0;
			}


			integrator += ki * error;
			
			if (Math.Abs(integrator) > intLimit)
			{
					integrator = Math.Sign(integrator) * intLimit;
			}
			
			double tmp = kp*error + integrator;
			
			if(Math.Abs(tmp) > maxModulus)
			{
				tmp = Math.Sign(tmp) * maxModulus;
			}

			double d = tmp - oldOutput;



			output = tmp + d*kd;

			

			return output;
		}

		public void reset()
		{
			output = 0;
			integrator = 0;
		}
	}
}
